unit Unit1;

{-------------------------------------------------------------------------------
 >> Demo 02 de uso da EPL2_Unit <<
	Este demo demonstra como gerar visualmente as etiquetas, adicionando
        quantos campos de texto e cdigo de barras voc desejar.
        Aps clicar no boto gerar so gerados os cdigos em Delphi para as
        chamadas da EPL2_Unit no seu programa e o script em EPL2 que geram a
        etiqueta montada na tela.

        Caso deseje recompilar o programa demo antes de adquirir o fonte da unit,
         necessrio copiar o arquivo EPL2_Unit.dcu para o diretrio Lib de
        instalao do Delphi, no caso do Delphi 6 pro exemplo
        C:\Arquivos de programas\Borland\Delphi6\Lib

        Caso j tenha adquirido a EPL2_Unit registrada, voc pode adiciona-la ao
        seu projeto, clicando em Menu> Project> Add to Project.        

 Para remover a mensagem de "No Registrado"  necessrio adquirir a EPL2_Unit
 com fontes. Para informaes sobre como adquirir o produto visite nosso site.

 Atenciosamente,
  Victory Fernandes
   TKS Software
   www.igara.com.br
-------------------------------------------------------------------------------}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Printers, Vcl.Imaging.jpeg;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Button1: TButton;
    Edit1: TEdit;
    Label2: TLabel;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Button2: TButton;
    Edit2: TEdit;
    Button3: TButton;
    Edit3: TEdit;
    Label5: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Memo1: TMemo;
    Memo2: TMemo;
    Button4: TButton;
    Button5: TButton;
    SaveDialog1: TSaveDialog;
    Button6: TButton;
    Panel2: TPanel;
    Image1: TImage;
    Label4: TLabel;
    Label3: TLabel;
    Label6: TLabel;
    Label36: TLabel;
    Image3: TImage;
    Image2: TImage;

    procedure Trata_Componentes;

    procedure Panel1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Panel1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure MyContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses EPL2_Unit;

//Gera Cdigo Delphi e Script EPL2 para os componentes do Panel
procedure TForm1.Trata_Componentes;
var
 taxa: double;
 i: integer;
begin
 taxa := 2.6;   //Taxa de converso entre distancia visual na tela e distancia relativa na etiqueta

 memo1.Lines.clear;
 memo1.lines.add('Abrir_Etiqueta_EPL2;');

 Abrir_Etiqueta_EPL2;

 for i := 0 to panel1.ComponentCount - 1 do
  begin
   if panel1.Components[i].ClassNameIs('TLabel') then
    begin
     //Gera Cdigo Delphi para componentes do tipo texto
     memo1.Lines.add('');
     memo1.lines.add('Texto_EPL2(' + inttostr(Round(TLabel(panel1.Components[i]).left * taxa)) + ', //Margem_Esquerda');
     memo1.lines.add('           ' + inttostr(Round(TLabel(panel1.Components[i]).top * taxa)) + ', //Margem_Superior');
     memo1.lines.add('           1, //Multiplicador_Horizontal');
     memo1.lines.add('           1, //Multiplicador_Vertical');
     memo1.lines.add('           ' + QuotedStr('N') + ', //Tipo_Fonte');
     memo1.lines.add('           ' + TLabel(panel1.Components[i]).caption + ', //Texto');
     memo1.lines.add('           false, //Imprime_Espelhado');
     memo1.lines.add('           0); //Rotacao');

     //Gera Script EPL2 para componentes do tipo texto
     Texto_EPL2(Round(TLabel(panel1.Components[i]).left  * taxa) ,   //Margem_Esquerda
                Round(TLabel(panel1.Components[i]).top  * taxa),   //Margem_Superior
                1,                                    //Multiplicador_Horizontal
                1,                                    //Multiplicador_Vertical
                'N',                                  //Tipo_Fonte
                TLabel(panel1.Components[i]).caption, //Texto
                false,                                //Imprime_Espelhado
                0);                                   //Rotacao

    end
   else if panel1.Components[i].ClassNameIs('TShape') then
    begin
     //Gera Cdigo Delphi para componentes do tipo Barras
     memo1.Lines.add('');
     memo1.lines.add('Codigo_Barras_EPL2(' + inttostr(Round(TShape(panel1.Components[i]).left * taxa)) + ', //margem_Esquerda');
     memo1.lines.add('                   ' + inttostr(Round(TShape(panel1.Components[i]).top * taxa)) + ', //margem_Superior');
     memo1.lines.add('                   2, //Barra_Fina');
     memo1.lines.add('                   5, //Barra_Grossa');
     memo1.lines.add('                   64, //Altura_Barra');
     memo1.lines.add('                   1, //Tipo_Codigo');
     memo1.lines.add('                   ' + TShape(panel1.Components[i]).name + ', //Texto');
     memo1.lines.add('                   True, //Imprime_Numero');
     memo1.lines.add('                   0); //Rotacao');

     //Gera Script EPL2 para componentes do tipo Barras
     Codigo_Barras_EPL2(Round(TShape(panel1.Components[i]).left  * taxa), //margem_Esquerda
                        Round(TShape(panel1.Components[i]).top  * taxa),  //margem_Superior
                        2,                                 //Barra_Fina
                        5,                                 //Barra_Grossa
                        64,                                //Altura_Barra
                        '1',                               //Tipo_Codigo
                        TShape(panel1.Components[i]).name, //Texto
                        True,                              //Imprime_Numero
                        0);                                //Rotacao
    end;
  end;

 memo1.Lines.add('');
 memo1.Lines.add('Fechar_Etiqueta_EPL2(false, ' + edit3.Text + '));');

 memo2.Clear;
 memo2.Lines.AddStrings(Fechar_Etiqueta_EPL2(false, strtoint(edit3.Text)));
end;

//Cria Componentes do Tipo Texto no Panel
procedure TForm1.Button1Click(Sender: TObject);
var
 MyLabel: TLabel;
begin
 try
  MyLabel := TLabel.Create(panel1);

  with MyLabel do
   begin
    Visible := true;
    Top := 8;
    Left := 8;
    Name := Trim(Edit1.text);           //No pode ter espao em branco no nome
    Caption := Edit1.text;
    Dragmode := dmAutomatic;            //Permite mover os componentes em Runtime
    Parent := panel1;
    OnContextPopup := MyContextPopup;   //Linka com a funo de excluso
   end;
 except
  Application.MessageBox('Erro ao tentar criar componente.' + #13 + 'Verifique se no existe algum componete com este mesmo nome.', 'Ateno!', mb_ok + mb_iconError)
 end;
end;

//Cria Componentes do Tipo Barras no Panel
procedure TForm1.Button2Click(Sender: TObject);
var
 MyShape: TShape;
begin
try
 MyShape := TShape.Create(panel1);
  with MyShape do
   begin
    Visible := true;
    Top := 8;
    Left := 8;
    Height := 41;
    Width := 81;
    Name := Trim(Edit2.text);           //No pode ter espao em branco no nome
    Dragmode := dmAutomatic;            //Permite mover os componentes em Runtime
    Parent := panel1;
    Brush.color := clblack;
    Brush.Style := bsVertical;
    Pen.Width := 2;
    OnContextPopup := MyContextPopup;   //Linka com a funo de excluso
   end;
 except
  Application.MessageBox('Erro ao tentar criar componente.' + #13 + 'Verifique se no existe algum componete com este mesmo nome.', 'Ateno!', mb_ok + mb_iconError)
 end;
end;

//Posiciona Objeto no ponto to cursor ao fim da operao de Drag
procedure TForm1.Panel1DragDrop(Sender, Source: TObject; X, Y: Integer);
begin
 TLabel(source).left := x;
 TLabel(source).Top  := y;
end;

//Aceita Drag de Objetos no Panel
procedure TForm1.Panel1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
 //Permite mover os componentes em Runtime
 Accept := true;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
 button1.Enabled := trim(edit1.Text) <> '';
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
 button2.Enabled := trim(edit2.Text) <> '';
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 //Chama funo que trata os componentes do panel e gera o cdigo delphi e o script EPL2
 Trata_Componentes;
end;

procedure TForm1.MyContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
 //Excluso de item do panel quando boto direito  clicado
 if application.MessageBox('Deseja excluir?', 'Ateno', mb_yesno + mb_iconquestion) = idyes then
  if Sender.ClassNameIs('TLabel') then
   TLabel(Sender).free
  else if Sender.ClassNameIs('TShape') then
   TShape(Sender).free;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 //impressao do codigo de barras
 if memo2.Lines.Count > 0 then
  begin
   Printer.BeginDoc;
   Impressao_paralela(memo2.Lines.Text);
   Printer.EndDoc;
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 //Salva arquivo de Codigo de Chamadas de Impressao
 if memo1.Lines.Count > 0 then
  begin
   savedialog1.InitialDir := extractfiledir(Application.ExeName);
   if savedialog1.Execute then
    memo1.Lines.SaveToFile(savedialog1.FileName);
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 //Salva arquivo de Codigo de Chamadas de Impressao
 if memo1.Lines.Count > 0 then
  begin
   savedialog1.InitialDir := extractfiledir(Application.ExeName);
   if savedialog1.Execute then
    memo2.Lines.SaveToFile(savedialog1.FileName);
  end;
end;

end.
